#include <cstdio>
#include "entity.h"

void enlist (int & list, int elm);
void delist (int & list, int elm);

void enlist (int & list, int elm)
{
// printf ("en %d %d\n", list, elm);
 if (list == -1)
 {
  list = elm;
  e_prev[list] = -1;
  e_next[list] = -1;
 }
 else
 {
  e_prev[elm] = -1;
  e_prev[list] = elm;
  e_next[elm] = list;
  list = elm;
 }
}

void delist (int & list, int elm)
{
// printf ("de %d %d\n", list, elm);
 assert (list != -1);
 if (list == elm)
 {
  if (e_next[elm] != -1) list = e_next[elm];
                  else list = e_prev[elm];
 }
 if (e_next[elm] != -1) e_prev[e_next[elm]] = e_prev[elm];
 if (e_prev[elm] != -1) e_next[e_prev[elm]] = e_next[elm];
}

void init_entity (void)
{
 int i;
 e_full = -1;
 e_free = -1;
 for (i = 0; i < MaxE; i++)
  enlist (e_free, i);
}

void create_entity (Entity * par, int num, int d_x, int d_y, int v_x, int v_y)
{
 int t;
 t = e_free;
 delist (e_free, t);
 enlist (e_full, t);
 entity[t] = new Entity (par, num, d_x, d_y, v_x, v_y);
}

void remove_entity (Entity * ent)
{
 int t;
 for (t = e_full; t != -1 && entity[t] != ent; t = e_next[t]) ;
 assert (t != -1);
 delist (e_full, t);
 enlist (e_free, t);
 delete entity[t];
}

Entity * entity [MaxE];
int e_prev [MaxE], e_next [MaxE];
int e_full, e_free;
