#include <cassert>
#include <cstring>
#include "generic.h"

void Generic::draw (int x, int y, int c)
{
 int i, j, i2, j2;
 if (c == NAC) c = col;
 x = (x - camera_x) >> H_Scale;
 y = (y - camera_y) >> V_Scale;
 for (i = 0, i2 = x; i < sx; i++, i2++)
  if (i2 >= 0 && i2 < SizeTX)
   for (j = 0, j2 = y; j < sy; j++, j2++)
    if (body[j][i] != '%')
     if (j2 >= 0 && j2 < SizeTY)
      if (zbuf[j2][i2] < z)
      {
       zbuf[j2][i2] = z;
       tbuf[j2][i2] = body[j][i];
       tcol[j2][i2] = c;
      }
}

Generic::Generic (int num)
{
 char buf [MaxL];
 FILE * f;
 int i, j;
 int cr, cg, cb;
 steam_num = 0;
 if ((f = fopen (gfn[num], "rt")) == NULL) assert (false);
 fgets (buf, MaxL, f);
 for (i = 0; buf[i] != '\n' && buf[i]; i++) ; buf[i] = 0;
 strcpy (name, buf);
 fgets (buf, MaxL, f);
 sscanf (buf, "%d%d%d", &sx, &sy, &z);
 assert (sx <= MaxEX);
 assert (sy <= MaxEY);
 fgets (buf, MaxL, f);
 sscanf (buf, "%d%d%d%d", &vel_left, &vel_up, &vel_right, &vel_down);
 fgets (buf, MaxL, f);
 sscanf (buf, "%d%d%d%d", &acc_left, &acc_up, &acc_right, &acc_down);
 fgets (buf, MaxL, f);
 sscanf (buf, "%d%d%d%d", &brk_left, &brk_up, &brk_right, &brk_down);
 fgets (buf, MaxL, f);
 sscanf (buf, "%X%X%X", &cr, &cg, &cb);
 col = makecol (cr, cg, cb);
 for (j = 0; j < sy; j++)
 {
  fgets (buf, MaxL, f);
  for (i = 0; buf[i] != '\n' && buf[i]; i++) ; buf[i] = 0;
  strcpy (body[j], buf);
  for (i = 0; body[j][i]; i++)
   if (body[j][i] == '?')
   {
    body[j][i] = '%';
    if (steam_num >= MaxSteam) assert (false);
    steam_x[steam_num] = i << H_Scale;
    steam_y[steam_num] = j << V_Scale;
    steam_num++;
   }
  for ( ; i < sx; i++) body[j][i] = '%';
 }
 fclose (f);
}

Generic::~Generic (void)
{
}

Generic * generic [GENERIC_NUM];
