#ifndef __generic_def__
#define __generic_def__
#include <cstdio>
#include "global.h"
#include "types.h"
const int MaxEX = 32, MaxEY = 32, MaxSteam = 12, MaxSmoke = 12;
const int H_Scale = 12, V_Scale = 12, P_Scale = 13, MaxPhase = 1 << P_Scale,
 MinPhase = MaxPhase >> 5, SmokeTime = 6, E_Scale = 6, SteamSparse = 50;

enum G_TYPES {T_RAIL, T_TREE, T_CLOUD, T_CAR, T_FLYER,
 T_MISSILE, T_BOMB, T_SMOKE, T_EFFECT, T_NUM};

enum Generics {G_R_HANGAR, G_R_PLATFORM, G_R_LIGHT, G_R_SOLID, G_R_NEW,
 G_R_LEFT, G_R_RIGHT, G_R_DAMAGED_1, G_R_DAMAGED_2, G_R_DAMAGED_3,

 G_TREE_1, G_TREE_2, G_TREE_3,

 G_CLOUD_1, G_CLOUD_2, G_CLOUD_3,

 G_LOCOMOTIVE, G_TENDER, G_SIGN_CAR, G_FUEL_CAR,
 G_AMMO_CAR, G_LAND_CAR, G_REPAIR_CAR, G_PASSENGER_CAR, G_BURNT_CAR,

 G_HELICOPTER, G_TRIPLANE, G_INTERCEPTOR, G_BOMBER, G_FIGHTER,
 
 G_BULLET, G_SMALL_ROCKET, GUN_SHOT, G_MEDIUM_ROCKET, G_LARGE_ROCKET,

 G_STOP_CHUTE, G_REPAIR_CHUTE, SMALL_BOMB,
 G_MEDIUM_BOMB, G_LARGE_BOMB, G_HUGE_BOMB,
 
 G_STEAM_1, G_STEAM_2, G_STEAM_3, G_STEAM_4, G_STEAM_5,

 G_SMOKE_1, G_SMOKE_2, G_SMOKE_3, G_SMOKE_4, G_SMOKE_5,
 
 G_ROTOR_1, G_ROTOR_2, G_ROTOR_3, G_ROTOR_4, G_ROTOR_5,
 G_ROTOR_6, G_ROTOR_7, G_ROTOR_8, G_ROTOR_9, G_ROTOR_10, GENERIC_NUM};

const char gfn [GENERIC_NUM] [MaxL] =
 {"dat/rail0.asc",
  "dat/rail1.asc",
  "dat/rail2.asc",
  "dat/rail3.asc",
  "dat/rail4.asc",
  "dat/rail5.asc",
  "dat/rail6.asc",
  "dat/rail7.asc",
  "dat/rail8.asc",
  "dat/rail9.asc",

  "dat/tree0.asc",
  "dat/tree1.asc",
  "dat/tree2.asc",

  "dat/cloud0.asc",
  "dat/cloud1.asc",
  "dat/cloud2.asc",

  "dat/car0.asc",
  "dat/car1.asc",
  "dat/car2.asc",
  "dat/car3.asc",
  "dat/car4.asc",
  "dat/car5.asc",
  "dat/car6.asc",
  "dat/car7.asc",
  "dat/car8.asc",

  "dat/chopper.asc",
  "dat/triplane.asc",
  "dat/plane0.asc",
  "dat/plane1.asc",
  "dat/plane2.asc",
 
  "dat/missile0.asc",
  "dat/missile1.asc",
  "dat/missile2.asc",
  "dat/missile3.asc",
  "dat/missile4.asc",

  "dat/bomb0.asc",
  "dat/bomb1.asc",
  "dat/bomb2.asc",
  "dat/bomb3.asc",
  "dat/bomb4.asc",
  "dat/bomb5.asc",
  
  "dat/steam0.asc",
  "dat/steam1.asc",
  "dat/steam2.asc",
  "dat/steam3.asc",
  "dat/steam4.asc",

  "dat/smoke0.asc",
  "dat/smoke1.asc",
  "dat/smoke2.asc",
  "dat/smoke3.asc",
  "dat/smoke4.asc",

  "dat/rotor0.asc",
  "dat/rotor1.asc",
  "dat/rotor2.asc",
  "dat/rotor3.asc",
  "dat/rotor4.asc",
  "dat/rotor5.asc",
  "dat/rotor6.asc",
  "dat/rotor7.asc",
  "dat/rotor8.asc",
  "dat/rotor9.asc"};

class Generic
{
friend class Entity;
private:
 char name [MaxL];
 int sx, sy, z, col;
 char body [MaxEY] [MaxEX];
 int steam_x [MaxSteam], steam_y [MaxSteam], steam_num;
 int vel_left, vel_up, vel_right, vel_down; // velocity
 int acc_left, acc_up, acc_right, acc_down; // acceleration
 int brk_left, brk_up, brk_right, brk_down; // braking
public:
 int get_max_vel () {return (vel_left > vel_right ? vel_left : vel_right);}

 void draw (int x, int y, int c = NAC);
 Generic (int num);
 ~Generic (void);
};

extern Generic * generic [GENERIC_NUM];
#endif // __generic_def__
